﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="CustomizedGV.aspx.cs" Inherits="Databinding.pages.CustomizedGV" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Customized GridView</title>
    <link href="..\site.css" rel="stylesheet" type="text/css" />
    

    <script type="text/javascript">
        function ConfirmDelete() {
            return confirm("Are you sure you want to delete this entry?");
        }
	</script>

    
    
</head>
<body>
		<!-- #Include File="header2.txt" -->

    
    <form id="form1" runat="server">
    <div>
    
        <h2>DB/GridView - Customizing the Display</h2>
        <p>
            Sort by LName or other to see that rows are highlighted where there is a 
            &quot;Beginner&quot; birthdate. Note that Edit does not work and I am not sure why. I have the EditItemTemplate set to display a TextBox with BDate; however, maybe I&#39;m not retrieving BDate correctly. I&#39;m trying to use a HiddenField for the BDate.<asp:ScriptManager ID="ScriptManager1" 
                runat="server">
            </asp:ScriptManager>
        </p>
        <asp:UpdatePanel ID="UpdatePanel1" runat="server">
            <ContentTemplate>
                <asp:ValidationSummary ID="ValidationSummary1" runat="server" />
                <asp:GridView ID="gvPlayers" runat="server" AllowPaging="True" 
                    AllowSorting="True" AutoGenerateColumns="False" DataKeyNames="PlayerID,BDate" 
                    DataSourceID="dsSqlPlayers" onrowdatabound="gvPlayers_RowDataBound" 
                    onselectedindexchanged="gvPlayers_SelectedIndexChanged">
                    <Columns>
                        <asp:CommandField ShowEditButton="True" ShowSelectButton="True" />
                        <asp:TemplateField>
                            <ItemTemplate>
                                <asp:LinkButton ID="LinkButton1" runat="server" CommandName="Delete" 
                                    onclientclick="return ConfirmDelete()">Delete</asp:LinkButton>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:BoundField DataField="PlayerID" HeaderText="PlayerID" 
                            InsertVisible="False" ReadOnly="True" SortExpression="PlayerID" 
                            Visible="False" />
                        <asp:BoundField DataField="LName" HeaderText="LName" SortExpression="LName" />
                        <asp:BoundField DataField="FName" HeaderText="FName" SortExpression="FName" />
                        <asp:TemplateField HeaderText="PNumber" SortExpression="PNumber">
                            <EditItemTemplate>
                                <asp:TextBox ID="gvTxtPNumber" runat="server" Text='<%# Bind("PNumber") %>'></asp:TextBox>
                                <asp:RangeValidator ID="gvRvalPNumber" runat="server" 
                                    ControlToValidate="gvTxtPNumber" Display="None" 
                                    ErrorMessage="Jersey Number must be between 1 and 99" MaximumValue="99" 
                                    MinimumValue="1" Type="Integer"></asp:RangeValidator>
                                <asp:RequiredFieldValidator ID="gvRfldValPNumber" runat="server" 
                                    ControlToValidate="gvTxtPNumber" Display="None" 
                                    ErrorMessage="Must supply a Jersey Number"></asp:RequiredFieldValidator>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="gvLblPNumber" runat="server" Text='<%# Bind("PNumber") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="BDate" SortExpression="BDate">
                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox1" runat="server" Text='<%# Eval("BDate") %>'></asp:TextBox>
                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="gvLblBDate" runat="server" 
                                    Text='<%# ConvertDateToLevel( (DateTime)Eval("BDate") ) %>'></asp:Label>
                                <asp:HiddenField ID="BDateHidden" runat="server" Value='<%# Eval("BDate") %>' 
                                    Visible="false" />
                            </ItemTemplate>
                        </asp:TemplateField>
                    </Columns>
                </asp:GridView>
                <br />
                <asp:SqlDataSource ID="dsSqlPlayers" runat="server" 
                   ConnectionString="<%$ ConnectionStrings:ConnectionStringPlayersDB %>" 
                    ProviderName="<%$ ConnectionStrings:ConnectionStringPlayersDB.ProviderName %>"
                    DeleteCommand="DELETE FROM [Players] WHERE [PlayerID] = @PlayerID" 
                    InsertCommand="INSERT INTO [Players] ([LName], [FName], [PNumber], [BDate]) VALUES (@LName, @FName, @PNumber, @BDate)" 
                    SelectCommand="SELECT [PlayerID], [LName], [FName], [PNumber], [BDate] FROM [Players]" 
                    UpdateCommand="UPDATE [Players] SET [LName] = @LName, [FName] = @FName, [PNumber] = @PNumber, [BDate] = @BDate WHERE [PlayerID] = @PlayerID">
                    <DeleteParameters>
                        <asp:Parameter Name="PlayerID" Type="Int32" />
                    </DeleteParameters>
                    <UpdateParameters>
                        <asp:Parameter Name="LName" Type="String" />
                        <asp:Parameter Name="FName" Type="String" />
                        <asp:Parameter Name="PNumber" Type="Int32" />
                        <asp:Parameter Name="BDate" Type="DateTime" />
                        <asp:Parameter Name="PlayerID" Type="Int32" />
                    </UpdateParameters>
                    <InsertParameters>
                        <asp:Parameter Name="LName" Type="String" />
                        <asp:Parameter Name="FName" Type="String" />
                        <asp:Parameter Name="PNumber" Type="Int32" />
                        <asp:Parameter Name="BDate" Type="DateTime" />
                    </InsertParameters>
                </asp:SqlDataSource>
                <br />
                <asp:TextBox ID="txtMsg" runat="server" Height="256px" ReadOnly="True" 
                    TextMode="MultiLine" Width="408px"></asp:TextBox>
            </ContentTemplate>
        </asp:UpdatePanel>
    </div>
    </form>
</body>
</html>
