﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Databinding.pages {
	public partial class CustomizedGV : System.Web.UI.Page {
        protected void Page_Load(object sender, EventArgs e) {
        }

        protected void gvPlayers_SelectedIndexChanged(object sender, EventArgs e) {
            // Access primary key from DataKeys
            int playerID = Convert.ToInt32(gvPlayers.DataKeys[gvPlayers.SelectedIndex].Values["PlayerID"]);

            // Access name from BoundFields
            string lName = gvPlayers.SelectedRow.Cells[2].Text;
            string fName = gvPlayers.SelectedRow.Cells[3].Text;

            // Access jersey num and level from TemplateFields
            Label lblJerseyNum = (Label)gvPlayers.SelectedRow.FindControl("gvLblPNumber");
            int jerseyNum = Convert.ToInt32(lblJerseyNum.Text);

            Label lblLevel = (Label)gvPlayers.SelectedRow.FindControl("gvLblBDate");
            string level = lblLevel.Text;

            // Access birth data from HiddenField
            //HiddenField BDateHidden =
            //  (HiddenField)gvPlayers.Rows[gvPlayers.SelectedIndex].FindControl("BDateHidden");

            HiddenField BDateHidden =
              (HiddenField)gvPlayers.SelectedRow.FindControl("BDateHidden");


            DateTime bDate = Convert.ToDateTime(BDateHidden.Value);

            // Build output string.
            string output = String.Format("PlayerID={0}, LName={1}, FName={2}, JerseyNum={3}, Level={4}, BDate={5}",
                                          playerID, lName, fName, jerseyNum, level, bDate.ToShortDateString());
            txtMsg.Text = output;
        }

        protected string ConvertDateToLevel(DateTime dt) {
            TimeSpan ts = DateTime.Now - dt;
            int days = ts.Days;

            if (days < 6570)  // 18 years old
                return "Beginner";
            else if (days < 8030) // 22 years old
                return "Intermediate";
            else
                return "Advanced";
        }

        protected void gvPlayers_RowDataBound(object sender, GridViewRowEventArgs e) {

            //if (e.Row.RowType == DataControlRowType.DataRow)
            //{
            //    if ((e.Row.RowState == DataControlRowState.Normal) || (e.Row.RowState == DataControlRowState.Alternate))
            //    {
            //        e.Row.BackColor = System.Drawing.Color.Blue;
            //        e.Row.ForeColor = System.Drawing.Color.White;            
            //    }
            //}
            if (gvPlayers.EditIndex == -1)
                if (e.Row.RowType == DataControlRowType.DataRow) {
                    Label l = (Label)e.Row.FindControl("gvLblBDate");

                    if (l.Text.Equals("Beginner")) {
                        //l.BackColor = System.Drawing.Color.Blue;
                        //l.ForeColor = System.Drawing.Color.White;
                        e.Row.BackColor = System.Drawing.Color.Blue;
                        e.Row.ForeColor = System.Drawing.Color.White;
                    }
                }
        }
    }
}