﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Deleting.aspx.cs" Inherits="Databinding.pages.Deleting" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Deleting From GridView</title>
    <link href="..\site.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript">
        function ConfirmDelete() {
            return confirm("Are you sure you want to delete this entry?");
        }
	</script>
    
</head>
<body>
		<!-- #Include File="header2.txt" -->

    
    <form id="form1" runat="server">
    <div>
    <asp:SqlDataSource ID="SqlDataSource1" runat="server" 
        ConnectionString="<%$ ConnectionStrings:ConnectionStringPatientsDB %>" 
        ProviderName="<%$ ConnectionStrings:ConnectionStringPatientsDB.ProviderName %>" 
        SelectCommand="SELECT * FROM [Patients]"></asp:SqlDataSource>
        <h2>GridView Deletion</h2>
        <p>
            Players Table -
            Deletes are confirmed on the client side. Players can always be deleted because 
            PlayerID is not a foreign key in any other table.</p>
        
        <asp:GridView ID="gvPlayers" runat="server" AllowPaging="True" 
            AllowSorting="True" AutoGenerateColumns="False" DataKeyNames="PlayerID" 
            onselectedindexchanged="gvPlayers_SelectedIndexChanged" 
            DataSourceID="dsSqlPlayers" PageSize="5">
            <Columns>
                <asp:CommandField ShowEditButton="True" 
                    ShowSelectButton="True" />
                <asp:TemplateField>
                    <ItemTemplate>
                        <asp:LinkButton ID="LinkButton1" runat="server" CommandName="Delete" 
                            onclientclick="return ConfirmDelete()">Delete</asp:LinkButton>
                    </ItemTemplate>
                </asp:TemplateField>
                <asp:BoundField DataField="PlayerID" HeaderText="PlayerID" 
                    InsertVisible="False" ReadOnly="True" SortExpression="PlayerID" />
                <asp:BoundField DataField="LName" HeaderText="LName" SortExpression="LName" />
                <asp:BoundField DataField="FName" HeaderText="FName" SortExpression="FName" />
                <asp:BoundField DataField="PNumber" HeaderText="PNumber" 
                    SortExpression="PNumber" />
                <asp:BoundField DataField="BDate" HeaderText="BDate" SortExpression="BDate" />
            </Columns>
        </asp:GridView>
        <asp:SqlDataSource ID="dsSqlPlayers" runat="server" 
                    ConnectionString="<%$ ConnectionStrings:ConnectionStringPlayersDB %>" 
                    ProviderName="<%$ ConnectionStrings:ConnectionStringPlayersDB.ProviderName %>"
            DeleteCommand="DELETE FROM [Players] WHERE [PlayerID] = @PlayerID" 
            InsertCommand="INSERT INTO [Players] ([LName], [FName], [PNumber], [BDate]) VALUES (@LName, @FName, @PNumber, @BDate)" 
            SelectCommand="SELECT [PlayerID], [LName], [FName], [PNumber], [BDate] FROM [Players]" 
            
            UpdateCommand="UPDATE [Players] SET [LName] = @LName, [FName] = @FName, [PNumber] = @PNumber, [BDate] = @BDate WHERE [PlayerID] = @PlayerID">
            <DeleteParameters>
                <asp:Parameter Name="PlayerID" Type="Int32" />
            </DeleteParameters>
            <UpdateParameters>
                <asp:Parameter Name="LName" Type="String" />
                <asp:Parameter Name="FName" Type="String" />
                <asp:Parameter Name="PNumber" Type="Int32" />
                <asp:Parameter Name="BDate" Type="DateTime" />
                <asp:Parameter Name="PlayerID" Type="Int32" />
            </UpdateParameters>
            <InsertParameters>
                <asp:Parameter Name="LName" Type="String" />
                <asp:Parameter Name="FName" Type="String" />
                <asp:Parameter Name="PNumber" Type="Int32" />
                <asp:Parameter Name="BDate" Type="DateTime" />
            </InsertParameters>
        </asp:SqlDataSource>
        <br />
        Patients Table -
        Deleting a record with related records in another table. PatientID is a foreign 
        key in other tables (Visits and Prescriptions). Unless a Patient has no visits, 
        then it cannot be deleted. Error message is determined on the server by using 
        try/catch on the delete.<br />
        <br />
        <asp:GridView ID="gvPatients" runat="server" AutoGenerateColumns="False" 
            DataKeyNames="PatientID" DataSourceID="dsSqlPatients" 
            onrowdeleted="gvPatients_RowDeleted">
            <Columns>
                <asp:CommandField ShowDeleteButton="True" />
                <asp:BoundField DataField="PatientID" HeaderText="PatientID" 
                    InsertVisible="False" ReadOnly="True" SortExpression="PatientID" 
                    Visible="False" />
                <asp:BoundField DataField="LastName" HeaderText="LastName" 
                    SortExpression="LastName" />
                <asp:BoundField DataField="FirstName" HeaderText="FirstName" 
                    SortExpression="FirstName" />
                <asp:BoundField DataField="Address" HeaderText="Address" 
                    SortExpression="Address" />
            </Columns>
        </asp:GridView>
        <asp:Label ID="lblDeleteError" runat="server" Font-Bold="True" ForeColor="Red" 
            Text="Patient can't be deleted. Visits and/or Prescriptions exist." 
            Visible="False"></asp:Label>
        <br />
        <asp:SqlDataSource ID="dsSqlPatients" runat="server" 
        ConnectionString="<%$ ConnectionStrings:ConnectionStringPatientsDB %>" 
        ProviderName="<%$ ConnectionStrings:ConnectionStringPatientsDB.ProviderName %>" 
            SelectCommand="SELECT [PatientID], [LastName], [FirstName], [Address] FROM [Patients]" 
            DeleteCommand="DELETE FROM [Patients] WHERE [PatientID] = ?" 
            InsertCommand="INSERT INTO [Patients] ([PatientID], [LastName], [FirstName], [Address]) VALUES (?, ?, ?, ?)" UpdateCommand="UPDATE [Patients] SET [LastName] = ?, [FirstName] = ?, [Address] = ? WHERE [PatientID] = ?">
			<DeleteParameters>
				<asp:Parameter Name="PatientID" Type="Int32" />
			</DeleteParameters>
			<InsertParameters>
				<asp:Parameter Name="PatientID" Type="Int32" />
				<asp:Parameter Name="LastName" Type="String" />
				<asp:Parameter Name="FirstName" Type="String" />
				<asp:Parameter Name="Address" Type="String" />
			</InsertParameters>
			<UpdateParameters>
				<asp:Parameter Name="LastName" Type="String" />
				<asp:Parameter Name="FirstName" Type="String" />
				<asp:Parameter Name="Address" Type="String" />
				<asp:Parameter Name="PatientID" Type="Int32" />
			</UpdateParameters>
		</asp:SqlDataSource>
        <br />
            <asp:TextBox ID="txtMsg" runat="server" Height="256px" ReadOnly="True" 
                TextMode="MultiLine" Width="408px"></asp:TextBox>
    
        <br />
        <br />
    
    </div>
    </form>
</body>
</html>
